function searchstatus()
{
	debugss( "new searchstatus" );
  return this;
}

searchstatus.prototype =
{
	mBarElementsLength: 19,
	mPrivateMode: null,

	mGoogleLastPR: null,
	mGoogleLastCat: null,
	mGoogleLastURL: null,
	mGooglePRCache: new Array(),
	mGooglePRCacheNa: new Array(),
	mGoogleCatCache: new Array(),
	mGoogleState: true, 
	mGoogleText: false,
	mGoogleRankOnly: true,
	
	mAlexaLastDoc: null,
	mAlexaLastURL: null,
	mAlexaRankCache: new Array(),
	mAlexaRankCacheNa: new Array(),
	mAlexaState: true,
	mAlexaText: false,
	
	mCompeteLastDoc: null,
	mCompeteLastURL: null,
	mCompeteRankCache: new Array(),
	mCompeteRankCacheNa: new Array(),
	mCompeteState: true,
	mCompeteText: false,
	
	mLinkscapeLastDoc: null,
	mLinkscapeLastURL: null,
	mLinkscapeRankCache: new Array(),
	mLinkscapeRankCacheNa: new Array(),
	mLinkscapeState: true,
	mLinkscapeText: false,	
	
	mHighlightNofollow: false,
	mHighlightColours: new Array( "255, 255, 160", "160, 255, 160", "160, 255, 255", "255, 160, 255", "255, 160, 160" ),
	mHighlightColourIndex: 0,
	
	mInstallDate: "19700101000000",
	mLocalIP: "127.0.0.1",
	mWords: "",
	
  init: function()
  {
		var preferencesService = Components.classes["@mozilla.org/preferences-service;1"].getService( Components.interfaces.nsIPrefService );
		var branch = preferencesService.getBranch( "extensions.searchstatus." );  	
  	
    moveBox( branch );

    this.startDate = new Date();

		this.mSearchStatusBar = document.getElementById( "searchstatus-bar" );	
		this.mCanonicalButton = document.getElementById( "canonical-button" );

    this.mGoogleRank = document.getElementById( "googlerank-status" );	
    this.mGoogleRankText = document.getElementById( "googlerank-status-text" );	
    this.mGoogleTooltip = document.getElementById( "googlerank-tooltip-value" );
    this.mGoogleLinks = document.getElementById( "googlerank-links" );
    this.mGoogleRelated = document.getElementById( "googlerank-related" );
    this.mGoogleCategory = document.getElementById( "googlerank-category" );
    
    this.mAlexaRank = document.getElementById( "alexarank-status" );	
    this.mAlexaRankText = document.getElementById( "alexarank-status-text" );
  	this.mAlexaTooltip = document.getElementById( "alexarank-tooltip-value" );
  	this.mAlexaRelated = document.getElementById( "alexarank-relatedlinks-menu" );
  	this.mAlexaCategory = document.getElementById( "alexarank-categories-menu" );
  	this.mAlexaIncoming = document.getElementById( "alexarank-incominglinks" );
  	this.mAlexaRelatedPopup = document.getElementById( "alexarank-relatedlinks-popup" );
  	this.mAlexaCategoryPopup = document.getElementById( "alexarank-categories-popup" );
  	this.mAlexaContactInfo = document.getElementById( "alexarank-contactinfo" );

    this.mCompeteRank = document.getElementById( "competerank-status" );	
    this.mCompeteRankText = document.getElementById( "competerank-status-text" );
  	this.mCompeteTooltip = document.getElementById( "competerank-tooltip-value" );
    this.mCompeteVisitors = document.getElementById( "competerank-visitors" );

    this.mLinkscapeRank = document.getElementById( "linkscaperank-status" );	
    this.mLinkscapeRankText = document.getElementById( "linkscaperank-status-text" );
  	this.mLinkscapeTooltip = document.getElementById( "linkscaperank-tooltip-value" );
    this.mLinkscapeLinkCount = document.getElementById( "linkscaperank-linkcount" );
    this.mLinkscapeDomainRank = document.getElementById( "linkscaperank-domainrank" );

		if( !branch.prefHasUserValue( "googlerankstatuspref.state" ) )
		{
			branch.setIntPref( "googlerankstatuspref.state", 1 );
		}
		this.mGoogleState = branch.getIntPref( "googlerankstatuspref.state" );   	
		
		if( !branch.prefHasUserValue( "googlerankstatustextpref.state" ) )
		{
			branch.setIntPref( "googlerankstatustextpref.state", 0 );
		}
		this.mGoogleText = branch.getIntPref( "googlerankstatustextpref.state" ); 
		
		if( !branch.prefHasUserValue( "alexarankstatuspref.state" ) )
		{
			branch.setIntPref( "alexarankstatuspref.state", 1 );
		}
		this.mAlexaState = branch.getIntPref( "alexarankstatuspref.state" );			
		
		if( !branch.prefHasUserValue( "alexarankstatustextpref.state" ) )
		{
			branch.setIntPref( "alexarankstatustextpref.state", 0 );
		}
		this.mAlexaText = branch.getIntPref( "alexarankstatustextpref.state" );	

		if( !branch.prefHasUserValue( "competerankstatuspref.state" ) )
		{
			branch.setIntPref( "competerankstatuspref.state", 0 );
		}
		this.mCompeteState = branch.getIntPref( "competerankstatuspref.state" );			
		
		if( !branch.prefHasUserValue( "competerankstatustextpref.state" ) )
		{
			branch.setIntPref( "competerankstatustextpref.state", 0 );
		}
		this.mCompeteText = branch.getIntPref( "competerankstatustextpref.state" );		
		
		if( !branch.prefHasUserValue( "linkscaperankstatuspref.state" ) )
		{
			branch.setIntPref( "linkscaperankstatuspref.state", 0 );
		}
		this.mLinkscapeState = branch.getIntPref( "linkscaperankstatuspref.state" );			
		
		if( !branch.prefHasUserValue( "linkscaperankstatustextpref.state" ) )
		{
			branch.setIntPref( "linkscaperankstatustextpref.state", 0 );
		}
		this.mLinkscapeText = branch.getIntPref( "linkscaperankstatustextpref.state" );		
		
		if( !branch.prefHasUserValue( "highlightnofollowpref.state" ) )
		{
			branch.setIntPref( "highlightnofollowpref.state", 0 );
		}
		this.mHighlightNofollow = branch.getIntPref( "highlightnofollowpref.state" );			
		
		if( !branch.prefHasUserValue( "installdate" ) )
		{
			var installdate = this.formatDate( this.startDate, "yyyyMMddhhmmss" );
			branch.setCharPref( "installdate", installdate );
		}
		this.mInstallDate = branch.getCharPref( "installdate" );

    if( !branch.prefHasUserValue( "searchstatus.privatesiteslist" ) )
    {
      var sites = new Array();
      if( branch.prefHasUserValue( "searchstatus.privatesites" ) )
      {
        sites = branch.getCharPref( "searchstatus.privatesites" ).split( "," );
        branch.clearUserPref( "searchstatus.privatesites" );
      }
      
      sites.push( "https://" );
      branch.setCharPref( "searchstatus.privatesiteslist", sites.join( "!" ) );
    }

		if( !branch.prefHasUserValue( "searchstatus.privatemode" ) )
		{
			branch.setBoolPref( "searchstatus.privatemode", false );
		}
		this.mPrivateMode = branch.getBoolPref( "searchstatus.privatemode" );

    window.setTimeout( function()
    {
      gSearchstatus.resolveLocalAddress();
    }, 1000 );    

		this.showFirstRunPage( branch );
  },
  
  resolveLocalAddress: function()
  {
    try
    {
      var dnsService = Components.classes["@mozilla.org/network/dns-service;1"].getService( Components.interfaces.nsIDNSService );
      var localname = dnsService.myHostName;
      var dnsRecord = dnsService.resolve( localname, false );
      this.mLocalIP = dnsRecord.getNextAddrAsString();
    }
    catch(e)
    {
      //ignore
    }
    
    if( this.mAlexaState != 0 )
    {
      this.mIPRequest = new XMLHttpRequest();
      this.mIPRequest.onload = onLocalRequestLoad;
      this.mIPRequest.open( "GET", "http://www.ippages.com/simple/" );
      this.mIPRequest.send( null );
    }
  },
  
  showFirstRunPage: function( branch )
  {
    var start = this.formatDate( this.startDate, "yyyyMMddhhmmss" );
    var ver = -1, install = start;

    var gExtensionManager = Components.classes["@mozilla.org/extensions/manager;1"].getService(Components.interfaces.nsIExtensionManager);
    var current = gExtensionManager.getItemForID("{d57c9ff1-6389-48fc-b770-f78bd89b6e8a}").version;
    
    try
    {
      install = branch.getCharPref( "installdate" );
      ver = branch.getCharPref( "version" );
    }
    catch( e )
    {
      //nothing
    }
    finally
    {
      if( start == install )
      {
        branch.setCharPref( "version", current );
  
        // Insert code for first run here
        window.setTimeout( function()
        {
          gBrowser.selectedTab = gBrowser.addTab("http://www.quirk.biz/searchstatus/welcome");
        }, 1500 );             
      }   
      else if( ver != current )
      { 
        branch.setCharPref( "version", current );
        
        // Insert code if version is different here => upgrade
        window.setTimeout( function()
        {
          gBrowser.selectedTab = gBrowser.addTab("http://www.quirk.biz/searchstatus/updated");
        }, 1500 );         
      }
    }
  },
  
  initStatus: function( doc, loadFresh )
  {
  	if( !this.isValidDocument( doc ) )
  	{
  		return;
  	}
  	
  	this.initGoogleStatus( doc, loadFresh );
  	this.initAlexaStatus( doc, loadFresh );
    this.initCompeteStatus( doc, loadFresh );
    this.initLinkscapeStatus( doc, loadFresh );
  	this.initHighlightStatus( doc );
  	this.initCanonical( doc );
 	},

  resetStatus: function( doc )
  {
  	if( !this.isValidDocument( doc ) )
  	{
  		return;
  	}

    this.resetGoogleStatus( doc );
		this.resetAlexaStatus( doc );
		this.resetCompeteStatus( doc );
		this.resetLinkscapeStatus( doc );
		this.resetHighlightStatus( doc );
		this.resetCanonical( doc );
  },
  
  isValidDocument: function( doc )
  {
  	if( doc && doc.location )
  	{
  		var url = new String( doc.location );
  		
  		if( url.indexOf( "chrome://" ) != 0 )
  		{
  			return true;
  		}
  	}
  	
  	return false;
  },  
  
  isPrivateMode: function()
  {
  	if( this.mPrivateMode == null )
  	{
  	  var preferencesService = Components.classes["@mozilla.org/preferences-service;1"].getService( Components.interfaces.nsIPrefService );
			var branch = preferencesService.getBranch( "extensions.searchstatus." ); 
	  	
			if( branch.prefHasUserValue( "searchstatus.privatemode" ) )
	  	{
	  		this.mPrivateMode = branch.getBoolPref( "searchstatus.privatemode" );
	  	}
	  	else
	  	{
	  		this.mPrivateMode = false;
	  	}
  	} 	
  	
  	return this.mPrivateMode;
  },
  
  setPrivateMode: function( mode )
  {
  	var preferencesService = Components.classes["@mozilla.org/preferences-service;1"].getService( Components.interfaces.nsIPrefService );
  	var branch = preferencesService.getBranch( "extensions.searchstatus." );
  	
  	if( !mode && branch.prefHasUserValue( "searchstatus.searchstatusprivatemode" ) && branch.getBoolPref( "searchstatus.searchstatusprivatemode" ) )
  	{
      //Don't turn off if set in Options
  	  debugss( "Leaving private mode on" );
  	  return;
  	}
  	
  	this.mPrivateMode = mode;
  	branch.setBoolPref( "searchstatus.privatemode", mode );
  },

  requestStatus: function( event, provider )
  {
		if( ( true || this.isPrivateMode() ) && event.button != 2 )
  	{
  		var localPrivateMode = this.mPrivateMode;
  		this.mPrivateMode = false;
  		
  		var doc = window._content.document;
  		
  		switch( provider )
  		{
  			case "google":
			  	this.initGoogleStatus( doc, true );
			  	break;
			  case "alexa":
			  	this.initAlexaStatus( doc, true );
			  	break;
			  case "compete":
					this.initCompeteStatus( doc, true );
					break;
				case "linkscape":
					this.initLinkscapeStatus( doc, true );
					break;
				default:
  				this.initStatus( doc, true );
  				break;
			}
  		
			this.mPrivateMode = localPrivateMode;
  	}
  },
  
  clearOptionsCache: function()
  {
  	this.mPrivateMode = null;
  },
  
  initHighlightStatus: function( doc )
  {
  	if( this.mHighlightNofollow )
  	{
  		debugss( "highlighting " + doc.location ); 
  		
  		this.highlightNofollow( doc, true );
  	}

		this.mHighlightColourIndex = 0;
 	},
  
  resetHighlightStatus: function( doc )
  {
  	var highlightnofollow = document.getElementById( "searchstatus-highlightnofollow" );
  	highlightnofollow.setAttribute( "checked", this.mHighlightNofollow ? "true" : "false" );  	
  },
  
  initCanonical: function( doc )
  {
		this.resetCanonical( doc );
  },
  
  resetCanonical: function( doc )
  {
  	if( !doc.getElementsByName || !this.mCanonicalButton )
  	{
  		return;
  	} 
  
    var canonicalLink = this.getCanonicalLink( doc );
  	if( !canonicalLink || canonicalLink.length == 0 )
  	{
  		this.mCanonicalButton.setAttribute( "status", "hidden" ); 
  	}
  	else
  	{
  	  var preferencesService = Components.classes["@mozilla.org/preferences-service;1"].getService( Components.interfaces.nsIPrefService );
      var branch = preferencesService.getBranch( "extensions.searchstatus." );
      
      var canonicalbutton;
      if( !branch.prefHasUserValue( "canonicalbutton.state" ) )
      {
        canonicalbutton = true;
        branch.setBoolPref( "canonicalbutton.state", canonicalbutton );
      }
      canonicalbutton = branch.getBoolPref( "canonicalbutton.state" );
      
      if( canonicalbutton )
      {
        this.mCanonicalButton.setAttribute( "link", canonicalLink );
    
        if( canonicalLink == doc.location.toString() )
        {
          this.mCanonicalButton.setAttribute( "status", "disabled" );
          this.mCanonicalButton.setAttribute( "tooltiptext", "Current location matches the specified canonical page" );
        }
        else
        {
          this.mCanonicalButton.removeAttribute( "status" );
          this.mCanonicalButton.setAttribute( "tooltiptext", "Go to the canonical page at " + canonicalLink );
        }
      }
      else
      {
        this.mCanonicalButton.setAttribute( "status", "hidden" ); 
      }
  	}
  },
  
  destroy: function()
  {

  },
  
  addZero: function(vNumber)
  { 
    return ( ( vNumber < 10 ) ? "0" : "" ) + vNumber;
  },
        
  formatDate: function( vDate, vFormat )
  { 
    var vDay              = this.addZero( vDate.getDate() ); 
    var vMonth            = this.addZero( vDate.getMonth() + 1 ); 
    var vYearLong         = this.addZero( vDate.getFullYear() ); 
    var vYearShort        = this.addZero( vDate.getFullYear().toString().substring( 3, 4 ) ); 
    var vYear             = ( vFormat.indexOf( "yyyy" ) > -1 ? vYearLong : vYearShort );
    var vHour             = this.addZero( vDate.getHours() ); 
    var vMinute           = this.addZero( vDate.getMinutes() ); 
    var vSecond           = this.addZero( vDate.getSeconds() ); 
    var vDateString       = vFormat.replace( /dd/g, vDay ).replace( /MM/g, vMonth ).replace( /y{1,4}/g, vYear );
    vDateString           = vDateString.replace( /hh/g, vHour ).replace( /mm/g, vMinute ).replace( /ss/g, vSecond );
    
    return vDateString;
  },
  
	setLocalIP: function()
	{
		var temp = this.mIPRequest.responseText;

  	var foo = temp.match(/[\d\.]+/gi);
		if( foo )
		{
			this.mLocalIP = foo[0];
			debugss( "setLocalIP: " + this.mLocalIP );
		}
	},

  showBackwardLinks: function( item, engine, pagespecific, includeinternal )
  {
  	var currurl = this.mGoogleLastURL;
  	var currdomain = currurl.replace( /https?:\/\/(.+?)\/.*$/gi, "$1" );
  	var rootdomain = getRootDomain( currdomain );  
  	var querylink = ( pagespecific ? currurl : rootdomain );

  	if( engine == "google" || engine == "all" )
  	{
  		var querystring = "http://www.google.com/search?q=" + ssUrlEncode( "link:" + querylink ) + ( includeinternal ? "" : "+" + ssUrlEncode( "-site:" + rootdomain ) ) + "&num=100";
	  	item.value = querystring;
	  	ssOpenItemUrl( item );
  	}
  	if( engine == "yahoo" || engine == "all" )
  	{
  		var querystring = "http://search.yahoo.com/search?p=" + ssUrlEncode( ( pagespecific ? "link:" : "linkdomain:" ) + querylink ) + ( includeinternal ? "" : "+" + ssUrlEncode( "-site:" + rootdomain ) );
	  	item.value = querystring;
	  	ssOpenItemUrl( item );
  	}
  	if( engine == "yahoose" || engine == "all" )
  	{
  		var querystring = "http://siteexplorer.search.yahoo.com/search?p=" + ssUrlEncode( querylink ) + "&bwm=i&bwmo=" + ( includeinternal ? "" : "d" ) + "&bwmf=" + ( pagespecific ? "u" : "s" );
	  	item.value = querystring;
	  	ssOpenItemUrl( item );
  	}  	
/*
  	if( engine == "msn" || engine == "all" )
  	{
  		var querystring = "http://search.msn.com/results.aspx?q=" + ssUrlEncode( ( pagespecific ? "link:" : "linkdomain:" ) + querylink ) + ( includeinternal ? "" : "+" + ssUrlEncode( "-site:" + rootdomain ) );
	  	item.value = querystring;
	  	ssOpenItemUrl( item );
  	}
*/  	
 	},
  
  showIndexedPages: function( item, engine )
  {
  	var currurl = this.mGoogleLastURL;
  	var currdomain = currurl.replace( /https?:\/\/(.+?)\/.*$/gi, "$1" );
  	var rootdomain = getRootDomain( currdomain );  	
  	
  	if( engine == "google" || engine == "all" )
  	{
  		var querystring = "http://www.google.com/search?q=" + ssUrlEncode( "site:" + rootdomain ) + "&num=100";
	  	item.value = querystring;
	  	ssOpenItemUrl( item );
  	}
  	if( engine == "yahoo" || engine == "all" )
  	{
  		var querystring = "http://search.yahoo.com/search?p=" + ssUrlEncode( "site:" + rootdomain );
	  	item.value = querystring;
	  	ssOpenItemUrl( item );
  	}
  	if( engine == "yahoose" || engine == "all" )
  	{
  		var querystring = "http://siteexplorer.search.yahoo.com/search?p=" + ssUrlEncode( rootdomain );
	  	item.value = querystring;
	  	ssOpenItemUrl( item );  	
  	}
  	if( engine == "msn" || engine == "all" )
  	{
  		var querystring = "http://search.msn.com/results.aspx?q=" + ssUrlEncode( "site:" + rootdomain );
	  	item.value = querystring;
	  	ssOpenItemUrl( item );
  	}
 	},
 	
 	showMetadata: function( item )
 	{
		window.openDialog( "chrome://searchstatus/content/metadata.xul", "searchstatus-metadata-dialog", "centerscreen,chrome,modal,resizable" );	
 	},
 	
 	highlightKeyword: function( item )
 	{
 		var selection = content.window.getSelection().toString();
 		if( selection == null || selection.length == 0 )
 		{
 			var selection = prompt( 'Enter keyphrase to highlight:', '' );
 		}
 		
 		if( selection != null )
 		{
			this.highlightSearchTerms( window._content.document, selection );
		}
 	},  	
 	
 	showKeywordDensity: function( item )
 	{
 		var selection = content.window.getSelection().toString();
 		if( selection == null || selection.length == 0 )
 		{
 			var selection = prompt( 'Enter keyphrase to match on:', '' );
 		}

		if( selection != null )
 		{
			this.highlightSearchTerms( window._content.document, selection );
 		
			window.openDialog( "chrome://searchstatus/content/kdreport.xul", "searchstatus-kdreport-dialog", "centerscreen,chrome,modal,resizable", selection );	
		}
 	}, 	
 	
 	showLinkReport: function( item )
 	{
		window.openDialog( "chrome://searchstatus/content/linkreport.xul", "searchstatus-linkreport-dialog", "centerscreen,chrome,modal,resizable" );	
 	}, 	 	
 	
 	showWhois: function( item )
 	{
 		var currurl = this.mGoogleLastURL;
  	var currdomain = currurl.replace( /https?:\/\/(.+?)\/.*$/gi, "$1" );

		var querystring = "http://www.whois-search.com/whois/" + currdomain;

		var preferencesService = Components.classes["@mozilla.org/preferences-service;1"].getService( Components.interfaces.nsIPrefService );
		var branch = preferencesService.getBranch( "extensions.searchstatus." );  
		if( branch.prefHasUserValue( "searchstatus.whoissource" ) )
		{
			if( branch.getIntPref( "searchstatus.whoissource" ) == 1 )
			{
				querystring = "http://whois.domaintools.com/" + currdomain;
			}
			else if( branch.getIntPref( "searchstatus.whoissource" ) == 2 )
			{
				querystring = "http://www.dnsstuff.com/tools/whois.ch?ip=" + currdomain;
			}
			else if( branch.getIntPref( "searchstatus.whoissource" ) == 3 )
			{
				querystring = "http://www.who.is/whois-com/ip-address/" + currdomain + "/";
			}			
		}

  	item.value = querystring;
  	ssOpenItemUrl( item );
 	},
 	
 	showArchive: function( item )
 	{
 		var currurl = this.mGoogleLastURL;
  	var currdomain = currurl.replace( /https?:\/\/(.+?)\/.*$/gi, "$1" );

		var querystring = "http://web.archive.org/web/*/http://" + currdomain;
  	item.value = querystring;
  	ssOpenItemUrl( item );
 	}, 	 	
 	
 	showDomainsOnIP: function( item )
  {
    var currurl = this.mGoogleLastURL;
    var currdomain = currurl.replace( /https?:\/\/(.+?)\/.*$/gi, "$1" );

    try
    {
      var cls = Components.classes['@mozilla.org/network/dns-service;1'];
      var iface = Components.interfaces.nsIDNSService;
      var dns = cls.getService(iface);
      var nsrecord = dns.resolve(currdomain, true);
      while( nsrecord && nsrecord.hasMore() ) 
      {
        var ip = nsrecord.getNextAddrAsString();
        var querystring = "http://www.bing.com/search?q=ip%3A" + ip;
        item.value = querystring;
        ssOpenItemUrl( item );
      }
    }
    catch(e) 
    {
      alert( "Sorry! " + currdomain + " is not resolvable." ); 
    }
  }, 
 	
 	showSitemapXml: function( item )
 	{
 		var currurl = this.mGoogleLastURL;
  	var currdomain = currurl.replace( /https?:\/\/(.+?)\/.*$/gi, "$1" );	

		var querystring = "http://" + currdomain + "/sitemap.xml";
  	item.value = querystring;
  	ssOpenItemUrl( item );		
 	},
 	
 	showRobotsTxt: function( item )
 	{
 		var currurl = this.mGoogleLastURL;
  	var currdomain = currurl.replace( /https?:\/\/(.+?)\/.*$/gi, "$1" );	

		var querystring = "http://" + currdomain + "/robots.txt";
  	item.value = querystring;
  	ssOpenItemUrl( item );		
 	},

  initGoogleStatus: function( doc, loadFresh ) 
  { 
  	var url = doc.location.toString();
  	if( url != window._content.document.location.toString() )
  	{
  		return;
  	}
  	
  	//url = url.replace( /\?.*$/g, "?" );

  	var reqgr = "info:" + url;
  	var reqgre = "info:" + ssUrlEncode( url ).replace( /_/, "%5F" );
  	this.mGoogleCH = gGoogleCHCalc.googleCH( gGoogleCHCalc.strord( reqgr ) );
  	this.mGoogleCH = "6" + gGoogleCHCalc.googleNewCh( this.mGoogleCH );

  	var querystring = this.isAnonymize() ? "http://www.anonymization.org/-" : "http://";
  	querystring += "toolbarqueries.google.com/search?client=navclient-auto&ch=" + 
  	               this.mGoogleCH + "&ie=UTF-8&oe=UTF-8&features=Rank" + 
  	               ( this.mGoogleRankOnly ? "" : ":FVN" ) + "&q=" + reqgre;
  	
    var urlIndex = 0;

		debugss( "For google url " + url + ": " + getArrayIndex( this.mGooglePRCache, this.mGoogleCH ) + ", " + getArrayIndex( this.mGooglePRCacheNa, this.mGoogleCH ) );

  	if( this.mGoogleState == 0 )
    {
  		//this.mGoogleRank.setAttribute( "hidden", "true" );
    }
  	else
  	{
  		if( this.mGoogleText == 0 )
  		{ 
  			this.mGoogleRank.setAttribute( "hidden", "false" );
  		}
  		else
  		{
  			this.mGoogleRankText.setAttribute( "hidden", "false" );
  		}
  		
  		var unrankable = this.getUnrankableStatus( url );
  		if( unrankable )
  		{
  			this.mGoogleRank.setAttribute( "status", "" );
  			this.mGoogleRankText.setAttribute( "label", "PageRank: " + unrankable );
  			this.mGoogleTooltip.setAttribute( "value", "PageRank: " + unrankable );
  			this.mGoogleLinks.setAttribute( "disabled", "true" );
  			this.mGoogleRelated.setAttribute( "disabled", "true" );
  			this.mGoogleCategory.setAttribute( "disabled", "true" );
  			this.mGoogleLastPR = -1;
  		}
  		else if( !loadFresh && ( urlIndex = getArrayIndex( this.mGooglePRCache, this.mGoogleCH ) ) >= 0 )
  	  {
  	    this.mGoogleLastPR = this.mGooglePRCache[urlIndex][1];
  	    this.mGoogleLastCat = this.mGoogleCatCache[urlIndex][1];
  	    this.mGoogleRank.setAttribute( "status", ( this.mGoogleLastCat == "n/a" ? "" : "c" ) + this.mGoogleLastPR );
  	    this.mGoogleRankText.setAttribute( "label", "PageRank: " + this.mGoogleLastPR + "/10" + ( this.mGoogleLastCat == "n/a" ? "" : "*" ) );
  	    this.mGoogleTooltip.setAttribute( "value", "PageRank: " + this.mGoogleLastPR + "/10" );
  	    this.mGoogleLinks.setAttribute( "disabled", "false" );
  	    this.mGoogleRelated.setAttribute( "disabled", "false" );
  	    this.mGoogleCategory.setAttribute( "disabled", this.mGoogleLastCat == "n/a" ? "true" : "false" );
  	    this.mGoogleCategory.setAttribute( "tooltiptext", this.mGoogleLastCat );
  	  }
      else if( !loadFresh && ( urlIndex = getArrayIndex( this.mGooglePRCacheNa, this.mGoogleCH ) ) >= 0 )
      {
        this.mGoogleLastPR = this.mGooglePRCacheNa[urlIndex][1];
        this.mGoogleLastCat = "n/a";
        this.mGoogleRank.setAttribute( "status", "-" );
        this.mGoogleRankText.setAttribute( "label", "PageRank: unranked" );
        this.mGoogleTooltip.setAttribute( "value", "PageRank: unranked" );
        this.mGoogleLinks.setAttribute( "disabled", "true" );
  	    this.mGoogleRelated.setAttribute( "disabled", "true" );
  	    this.mGoogleCategory.setAttribute( "disabled", "true" );
  	    this.mGoogleCategory.setAttribute( "tooltiptext", this.mGoogleLastCat );
      }	  
  		else
  		{
  			this.mGoogleRank.setAttribute( "status", "-" );
  			this.mGoogleRankText.setAttribute( "label", "PageRank: unranked" );
  			this.mGoogleTooltip.setAttribute( "value", "PageRank: unranked" );
  			this.mGoogleLinks.setAttribute( "disabled", "true" );
  			this.mGoogleRelated.setAttribute( "disabled", "true" );
  			this.mGoogleCategory.setAttribute( "disabled", "true" );			
  			
  			if( querystring != this.mGoogleQuerystring || loadFresh )
  			{
	  			debugss( "asking google..." );
	  			
	  			this.mGoogleRequest = new XMLHttpRequest();
	  	    this.mGoogleRequest.onload = onGoogleRequestLoad;
	  	    this.mGoogleRequest.open( "GET", querystring );
	  	    this.mGoogleRequest.setRequestHeader( "User-Agent", "Mozilla/4.0 (compatible; GoogleToolbar 2.0.114-big; Windows XP 5.1)" );
	  			this.mGoogleRequest.send( null );
	  			this.mGoogleQuerystring = querystring;
  			}
  		}
  	}
  	
  	this.mGoogleLastURL = url;
  },

  setGoogleStatus: function()
  {	
  	debugss( "setGoogleStatus " + this.mGoogleRequest );
  	
  	var temp = this.mGoogleRequest.responseText;

  	var foo = temp.match(/Rank_.*?:.*?:(\d+)/i);
    
    var pr = (foo) ? foo[1] : "-1";
    var foo2 = temp.match(/FVN_.*?:.*?:(?:Top\/)?([^\s]+)/i);
    var cat = (foo2) ? foo2[1] : "n/a";

  	if( pr != -1 )
  	{
  	  this.mGoogleRank.setAttribute( "status", cat == "n/a" ? pr : "c" + pr );
			this.mGoogleRankText.setAttribute( "label", "PageRank: " + pr + "/10" + ( cat == "n/a" ? "" : "*" ) );
  		this.mGoogleTooltip.setAttribute( "value", "PageRank: " + pr + "/10" );
  		this.mGoogleLinks.setAttribute( "disabled", "false" );
  		this.mGoogleRelated.setAttribute( "disabled", "false" );
  	}
  	else
  	{
  	  this.mGoogleRank.setAttribute( "status", "-" );
  		this.mGoogleRankText.setAttribute( "label", "PageRank: unranked" );
  		this.mGoogleTooltip.setAttribute( "value", "PageRank: unranked" );
  		this.mGoogleLinks.setAttribute( "disabled", "true" );
  		this.mGoogleRelated.setAttribute( "disabled", "true" );
  	}
  	
  	this.mGoogleCategory.setAttribute( "disabled", cat == "n/a" ? "true" : "false" );
  	this.mGoogleCategory.setAttribute( "tooltiptext", cat );
  	
  	this.mGoogleLastPR = pr;
  	this.mGoogleLastCat = cat;
  	
  	if( this.mGoogleLastPR != -1 )
  	{
  		this.mGooglePRCache.push( new Array( this.mGoogleCH, this.mGoogleLastPR ) );
  		this.mGoogleCatCache.push( new Array( this.mGoogleCH, this.mGoogleLastCat ) );
  	}
  	else
  	{
  		this.mGooglePRCacheNa.push( new Array( this.mGoogleCH, this.mGoogleLastPR ) );	
  	}
  },
  
  resetGoogleStatus: function( doc )
  {
  	var showgoogle = document.getElementById( "searchstatus-showgooglerank" );
  	showgoogle.setAttribute( "checked", this.mGoogleState ? "true" : "false" );	
  	
  	var showgoogletext = document.getElementById( "googlerank-showtext" );
  	showgoogletext.setAttribute( "checked", this.mGoogleText ? "true" : "false" );	
  	
  	var url = doc.location.toString();
  	url = url.replace( /\?.*$/g, "?" );
  	
  	if( this.mGoogleState == 0 )
  	{
  		this.mGoogleRank.setAttribute( "hidden", "true" );
  		this.mGoogleRankText.setAttribute( "hidden", "true" );
  	}
  	else 
  	{
  		this.mGoogleRank.setAttribute( "hidden", this.mGoogleText ? "true" : "false" );
  		this.mGoogleRankText.setAttribute( "hidden", this.mGoogleText ? "false" : "true" );
  		
  		if( url == this.mGoogleLastURL )
  		{
  		  if( this.mGoogleLastPR == -1 )
  		  {
  		    var googlePattern = /^http:\/\/.*google\..*\/(search|images|groups|news).*/;
          var unrankable = this.getUnrankableStatus( url, googlePattern );
  		    if( !unrankable )
  		    {
  		      unrankable = "unranked";
  		    }
  		  
  		    this.mGoogleRank.setAttribute( "status", unrankable == "unranked" ? "-"  : "" );
  		  	this.mGoogleRankText.setAttribute( "label", "PageRank: " + unrankable );
  				this.mGoogleTooltip.setAttribute( "value", "PageRank: " + unrankable );	
  				this.mGoogleLinks.setAttribute( "disabled", "true" );
  				this.mGoogleRelated.setAttribute( "disabled", "true" );
  				this.mGoogleCategory.setAttribute( "disabled", "true" );
  				this.mGoogleCategory.setAttribute( "tooltiptext", this.mGoogleLastCat );
  			}
  			else
  			{
  			  this.mGoogleRank.setAttribute( "status", ( this.mGoogleLastCat == "n/a" ? "" : "c" ) + this.mGoogleLastPR );
  				this.mGoogleRankText.setAttribute( "label", "PageRank: " + this.mGoogleLastPR + "/10" + ( this.mGoogleLastCat == "n/a" ? "" : "*" ) );
  				this.mGoogleTooltip.setAttribute( "value", "PageRank: " + this.mGoogleLastPR + "/10" );
  				this.mGoogleLinks.setAttribute( "disabled", "false" );
  				this.mGoogleRelated.setAttribute( "disabled", "false" );
  				this.mGoogleCategory.setAttribute( "disabled", this.mGoogleLastCat == "n/a" ? "true" : "false" );
  	    	this.mGoogleCategory.setAttribute( "tooltiptext", this.mGoogleLastCat );				
  			}
  		}
  		else
  		{
  		  this.initGoogleStatus( doc );	
  		}
  	}
  },
  
  getUnrankableStatus: function( url, customPattern )
  {
    var pattern = /^https?:\/\/([^\/]*\.[^\/]*)/;
    var match = pattern.exec( url );
     
    if( !match || match[1].indexOf( "127.") == 0 || match[1].indexOf( "10.") == 0 || match[1].indexOf( "192.168.") == 0 || match[1].indexOf( "localhost") == 0 || 
        ( customPattern && customPattern.test( url ) ) )
    {
      return "unrankable";
    }
    else if( this.isPrivateMode() )
    {
      return "click...";
    }
    else if( this.isPrivateSite( url ) )
    {
      return "private";
    }

    return null;
  },

  showGoogleCategory: function( item )
  {
  	var cat = item.getAttribute( "tooltiptext" );
  	if( cat && cat != "n/a" )
  	{
  		var link = "http://directory.google.com/Top/" + encodeURI( cat + "/" );
  		ssOpenUrl( link );
  	}
  },
  
  showGoogleCache: function( item )
  {
  	var currurl = this.mGoogleLastURL;
  	var querystring = "http://www.google.com/search?q=" + ssUrlEncode( "cache:" + currurl );
  	
  	item.value = querystring;
  	ssOpenItemUrl( item );
  },  

  showRelatedLinks: function( item, url )
  {
  	var currurl = ( url == "" ? this.mGoogleLastURL : url );
  	var querystring = "http://www.google.com/search?q=" + ssUrlEncode( "related:" + currurl );
  	
  	item.value = querystring;
  	ssOpenItemUrl( item );	
  },
  
  showGoogleTrends: function( item )
 	{
 		var selection = content.window.getSelection().toString();
 		if( selection == null || selection.length == 0 )
 		{
 			var selection = prompt( 'Enter keyphrase to search on:', '' );
 		}
 		
 		if( selection != null )
 		{
	 		var querystring = "http://www.google.com/trends?q=" + ssUrlEncode( selection );
	  	
	  	item.value = querystring;
	  	ssOpenItemUrl( item );
	 	}
 	},  

  switchGoogleState: function()
  {
		var preferencesService = Components.classes["@mozilla.org/preferences-service;1"].getService( Components.interfaces.nsIPrefService );
		var branch = preferencesService.getBranch( "extensions.searchstatus." );    	
  	
  	if( this.mGoogleState == 0 )
  	{
  		branch.setIntPref( "googlerankstatuspref.state", 1 );
  	  this.mGoogleState = 1;
  	  this.mGoogleRank.setAttribute( "hidden", this.mGoogleText ? "true" : "false" );
  	  this.mGoogleRankText.setAttribute( "hidden", this.mGoogleText ? "false" : "true" );
  	}
  	else
  	{
  		branch.setIntPref( "googlerankstatuspref.state", 0 );
  	  this.mGoogleState = 0;
  	  this.mGoogleRank.setAttribute( "hidden", "true" );
  	  this.mGoogleRankText.setAttribute( "hidden", "true" );
  	}
  	
  	this.initGoogleStatus( window._content.document );
  },
  
  switchGoogleTextState: function()
  {
		var preferencesService = Components.classes["@mozilla.org/preferences-service;1"].getService( Components.interfaces.nsIPrefService );
		var branch = preferencesService.getBranch( "extensions.searchstatus." );  	
  	
  	if( this.mGoogleText == 0 )
  	{
  		branch.setIntPref( "googlerankstatustextpref.state", 1 );
  	  this.mGoogleText = 1;
  	  this.mGoogleRank.setAttribute( "hidden", "true" );
  	  this.mGoogleRankText.setAttribute( "hidden", "false" );
  	}
  	else
  	{
  		branch.setIntPref( "googlerankstatustextpref.state", 0 );
  	  this.mGoogleText = 0;
  	  this.mGoogleRank.setAttribute( "hidden", "false" );
  	  this.mGoogleRankText.setAttribute( "hidden", "true" );
  	}
  	
  	this.initGoogleStatus( window._content.document );
  },  

  hideGoogleTooltip: function()
  {
  	this.mGoogleRank.setAttribute( "tooltip", "" );
  },
  
  showGoogleTooltip: function()
  {
  	this.mGoogleRank.setAttribute( "tooltip", "googlerank-tooltip" );
  },
 
  initAlexaStatus: function( doc, loadFresh ) 
  { 
  	var url = doc.location.toString();
  	if( url != window._content.document.location.toString() )
  	{
  		return;
  	}
  		
    var urlIndex = 0;
    
   	debugss( "For alexa url " + url + ": " + getArrayIndex( this.mAlexaRankCache, url ) + ", " + getArrayIndex( this.mAlexaRankCacheNa, url ) );

  	if( this.mAlexaState == 0 )
    {
    	//this.mAlexaRank.setAttribute( "hidden", "true" );
    }
  	else
  	{
  		if( this.mAlexaText == 0 )
  		{ 
  			this.mAlexaRank.setAttribute( "hidden", "false" );
  		}
  		else
  		{
  			this.mAlexaRankText.setAttribute( "hidden", "false" );
  		}
  		
      var unrankable = this.getUnrankableStatus( url );
      if( unrankable )
      {
  			this.mAlexaLastDoc = unrankable;
  			this.initAlexaFromDoc( this.mAlexaLastDoc );
  		}
  		else if( !loadFresh && ( urlIndex = getArrayIndex( this.mAlexaRankCache, url ) ) >= 0 )
  	  {
  	    this.mAlexaLastDoc = this.mAlexaRankCache[urlIndex][1];
  	    this.initAlexaFromDoc( this.mAlexaLastDoc );
  	  }	
  		else if( !loadFresh && ( urlIndex = getArrayIndex( this.mAlexaRankCacheNa, url ) ) >= 0 )
  	  {
  	    this.mAlexaLastDoc = this.mAlexaRankCacheNa[urlIndex][1];
  	    this.initAlexaFromDoc( this.mAlexaLastDoc );
  	  }		  
  		else
  		{
  		  this.mAlexaLastDoc = "unranked";
        this.initAlexaFromDoc( this.mAlexaLastDoc );
  			
  			var encodedUrl = ssUrlEncode( url );
  			var querystring = this.isAnonymize() ? "http://www.anonymization.org/-" : "http://";
  			//querystring += "http://data.alexa.com/data/+wQ411en8000lA?cli=10&dat=snba&ver=7.0&cdt=alx_vw%3D20%26wid%3D12206%26act%3D00000000000%26ss%3D1680x1050%26bw%3D964%26t%3D0%26ttl%3D35371%26vis%3D1%26rq%3D4&url=" + encodedUrl;
				//querystring += "aws-beta.amazon.com/onca/xml?Service=AlexaWebInfoService&SubscriptionId=1ASYC6ZNPG2STTW2TXG2&Operation=UrlInfo&ResponseGroup=Rank,Related,ContactInfo&Uip=" + this.mLocalIP + "&Uid=" + this.mInstallDate + "&Url=" + encodedUrl;
				querystring += "xml.alexa.com/data?cli=10&dat=nsa&ver=quirk-searchstatus&uid=" + this.mInstallDate + "&userip=" + this.mLocalIP + "&url=" + encodedUrl;

  			if( querystring != this.mAlexaQuerystring || loadFresh )
  			{
					debugss( "asking alexa..." );
  			
	  			this.mAlexaRequest = new XMLHttpRequest();
	  	    this.mAlexaRequest.onload = onAlexaRequestLoad;
	  	    this.mAlexaRequest.open( "GET", querystring );
	  	    //this.mAlexaRequest.setRequestHeader( "User-Agent", "Mozilla/4.0 (compatible; MSIE 6.0; Windows NT 5.1; .NET CLR 1.1.4322; Alexa Toolbar)" );
	  	    //this.mAlexaRequest.setRequestHeader( "If-Modified-Since", "Thu, 26 Aug 2002 08:24:16 GMT" );
	  			this.mAlexaRequest.send( null );
  				this.mAlexaQuerystring = querystring;
  			}
  		}
  	}

  	this.mAlexaLastURL = url;
  },

  setAlexaStatus: function()
  {
  	var aDoc = this.mAlexaRequest.responseXML;
  	debugss( "setAlexaStatus " + aDoc );
  	
  	this.initAlexaFromDoc( aDoc );
  	this.mAlexaLastDoc = aDoc;
  	
  	if( aDoc == -1 )
  	{
  		this.mAlexaRankCacheNa.push( new Array( this.mAlexaLastURL, aDoc ) );  		
  	}
  	else
  	{
  		this.mAlexaRankCache.push( new Array( this.mAlexaLastURL, aDoc ) );
  	}
  },

  initAlexaFromDoc: function( aDoc )
  {
  	var len = this.mAlexaRelatedPopup.childNodes.length;
  	for( i = 0; i < len; i++ )
  	{
  		this.mAlexaRelatedPopup.removeChild( this.mAlexaRelatedPopup.childNodes.item( 0 ) );
  	}
  	var len = this.mAlexaCategoryPopup.childNodes.length;
  	for( i = 0; i < len; i++ )
  	{
  		this.mAlexaCategoryPopup.removeChild( this.mAlexaCategoryPopup.childNodes.item( 0 ) );
  	}  	

  	var len = this.mSearchStatusBar.childNodes.length;
  	for( i = this.mBarElementsLength; i < len; i++ )
  	{
  		this.mSearchStatusBar.removeChild( this.mSearchStatusBar.childNodes.item( this.mBarElementsLength ) ); 
  	}

    if( aDoc == null || aDoc == -1 )
    {
      aDoc = "unrankable";
    }

  	if( typeof aDoc == "string" )
  	{
  		this.mAlexaRank.setAttribute( "status", aDoc == "unranked" ? "-" : "" );
  		this.mAlexaRankText.setAttribute( "label", "Alexa Rank: " + aDoc );
  		this.mAlexaTooltip.setAttribute( "value", "Alexa Rank: " + aDoc );
  		this.mAlexaRelated.setAttribute( "label", "Related Links" );
  		this.mAlexaRelated.setAttribute( "disabled", "true" );
  		this.mAlexaCategory.setAttribute( "label", "Categories" );
  		this.mAlexaCategory.setAttribute( "disabled", "true" );
  		this.mAlexaContactInfo.setAttribute( "disabled", "true" );
  	}
  	else
  	{
  		if( aDoc.getElementsByTagName( "POPULARITY" ).length > 0 )
  		{
	  		var rankTextAttr = aDoc.getElementsByTagName( "POPULARITY" ).item( 0 ).attributes.getNamedItem( "TEXT" );
	  		var ar = rankTextAttr.nodeValue;
	  		
	  		this.mAlexaRank.setAttribute( "status", this.getAlexaStatus( ar ) );
	  		this.mAlexaRankText.setAttribute( "label", "Alexa Rank: " + ssFormatInteger( ar ) );
	  		this.mAlexaTooltip.setAttribute( "value", "Alexa Rank: " + ssFormatInteger( ar ) );
	  	}
	  	else
	  	{
	  		this.mAlexaRank.setAttribute( "status", "-" );
	  		this.mAlexaRankText.setAttribute( "label", "Alexa Rank: unranked" );
  			this.mAlexaTooltip.setAttribute( "value", "Alexa Rank: unranked" );
	  	}

  		var linkNodes = aDoc.getElementsByTagName( "RL" );
  		if( linkNodes.length > 0 )
  		{
  			this.mAlexaRelated.setAttribute( "label", "Related Links (" + linkNodes.length + ")" );
  			this.mAlexaRelated.setAttribute( "disabled", "false" );
  			
  			for( i = 0; i < linkNodes.length; i++ )
  			{
  				var linkNode = linkNodes.item( i );
  				var title = linkNode.attributes.getNamedItem( "TITLE" ).nodeValue;
  				var url = "http://" + linkNode.attributes.getNamedItem( "HREF" ).nodeValue;
  				
  				var item = document.createElement( "menuitem" );
  				item.setAttribute( "label", title );
  				item.setAttribute( "value", url );
  				item.setAttribute( "tooltiptext", url );
  				item.setAttribute( "oncommand", "ssOpenItemUrl(event.target);" );
  		
  				this.mAlexaRelatedPopup.appendChild( item );
  				
  				if( this.isRelatedLinksOnBar() )
  				{
	  				var rlPanel = document.createElement( "statusbarpanel" );
			
	  				rlPanel.setAttribute( "label", ( title.length > 10 ? title.substring( 0, 10 ) + "..." : title ) );
	  				rlPanel.setAttribute( "value", url );
	  				rlPanel.setAttribute( "tooltiptext", title + " - " + url );
	  				rlPanel.setAttribute( "statustext", url );
	  				rlPanel.setAttribute( "onclick", "ssOpenUrl(event.target.getAttribute('statustext'));" );
	  				
						this.mSearchStatusBar.appendChild( rlPanel );
					}
  			}
  		}
  		else
  		{
  			this.mAlexaRelated.setAttribute( "label", "Related Links" );
  			this.mAlexaRelated.setAttribute( "disabled", "true" );
  		}
  		
  		var categoryNodes = aDoc.getElementsByTagName( "CAT" );
  		if( categoryNodes.length > 0 )
  		{
  			this.mAlexaCategory.setAttribute( "label", "Categories (" + categoryNodes.length + ")" );
  			this.mAlexaCategory.setAttribute( "disabled", "false" );
  			for( i = 0; i < categoryNodes.length; i++ )
  			{
  				var categoryNode = categoryNodes.item( i );
  				var title = categoryNode.attributes.getNamedItem( "TITLE" ).nodeValue;
  				var path = categoryNode.attributes.getNamedItem( "ID" ).nodeValue;
  				
  				var catmenu = document.createElement( "menu" );
  				catmenu.setAttribute( "label", title );
  				catmenu.setAttribute( "value", path );
  				catmenu.setAttribute( "tooltiptext", path );
  				
  				var catpopup = document.createElement( "menupopup" );
  				var catalexaitem = document.createElement( "menuitem" );
  				catalexaitem.setAttribute( "label", "Alexa" );
  				catalexaitem.setAttribute( "value", path );
  				catalexaitem.setAttribute( "tooltiptext", path );
  				catalexaitem.setAttribute( "oncommand", "gSearchstatus.showAlexaCategory(event.target);" );
  				catpopup.appendChild( catalexaitem );
  				
  				var catdmozitem = document.createElement( "menuitem" );
  				catdmozitem.setAttribute( "label", "DMOZ" );
  				catdmozitem.setAttribute( "value", path );
  				catdmozitem.setAttribute( "tooltiptext", path );
  				catdmozitem.setAttribute( "oncommand", "gSearchstatus.showDMOZCategory(event.target);" );  				
  				catpopup.appendChild( catdmozitem );
  				
  				catmenu.appendChild( catpopup );
  				
  				this.mAlexaCategoryPopup.appendChild( catmenu );
  			}
  			
  			if( this.mAlexaRank.getAttribute( "status" ).length > 0 )
  			{
  				this.mAlexaRank.setAttribute( "status", "c" + this.getAlexaStatus( ar ) );
  				this.mAlexaRankText.setAttribute( "label", "Alexa Rank: " + ssFormatInteger( ar ) + "*" );
  			}
  		}
  		else
  		{
  			this.mAlexaCategory.setAttribute( "label", "Categories" );
  			this.mAlexaCategory.setAttribute( "disabled", "true" );
  		}  		

			var contactinfo = ( aDoc.getElementsByTagName( "OWNER" ).length > 0 );
			this.mAlexaContactInfo.setAttribute( "disabled", contactinfo ? "false" : "true" );
  	}
  },

  getAlexaStatus: function( ar )
  {
  	if( ar < 0 )
  	{
  		return 0;
  	}
  	
  	var rank = Math.log( ar ) / Math.log( 5 );
  	rank = Math.floor( rank );
  	if( rank > 10 )
  	{
  		rank = 10;	
  	}
  	
  	return ( 10 - rank );
  },

  resetAlexaStatus: function( doc )
  {
  	var showalexa = document.getElementById( "searchstatus-showalexarank" );
  	showalexa.setAttribute( "checked", this.mAlexaState ? "true" : "false" );
  	
  	var showalexatext = document.getElementById( "alexarank-showtext" );
  	showalexatext.setAttribute( "checked", this.mAlexaText ? "true" : "false" );	  	
  	
  	var url = doc.location.toString();
  	
  	if( this.mAlexaState == 0 )
  	{
    	this.mAlexaRank.setAttribute( "hidden", "true" );
    	this.mAlexaRankText.setAttribute( "hidden", "true" );
  	}
  	else
  	{
  		this.mAlexaRank.setAttribute( "hidden", this.mAlexaText ? "true" : "false" );
  		this.mAlexaRankText.setAttribute( "hidden", this.mAlexaText ? "false" : "true" );
  		
  		if( url == this.mAlexaLastURL )
  		{
  			this.initAlexaFromDoc( this.mAlexaLastDoc );
  		}
  		else
  		{
  		  this.initAlexaStatus( doc );	
  		}
  	}
  },
	
	getDomain: function()
	{
		var url = new String( window._content.document.location );
  	return url.replace( /https?:\/\/(.+?)\/.*$/gi, "$1" );
	},
	
	getDomainAndPath: function()
	{
		var url = new String( window._content.document.location );
  	return url.replace( /https?:\/\/(.+)$/gi, "$1" );
	},

	getDomainUrl: function()
	{
		var url = new String( window._content.document.location );
  	return url.replace( /https?:\/\/(.+?)\/.*$/gi, "http://$1/" );
	},

  switchAlexaState: function()
  {
		var preferencesService = Components.classes["@mozilla.org/preferences-service;1"].getService( Components.interfaces.nsIPrefService );
		var branch = preferencesService.getBranch( "extensions.searchstatus." );  	
  	
  	if( this.mAlexaState == 0 )
  	{
  		branch.setIntPref( "alexarankstatuspref.state", 1 );
  	  this.mAlexaState = 1;
  	  this.mAlexaRank.setAttribute( "hidden", this.mAlexaText ? "true" : "false" );
  		this.mAlexaRankText.setAttribute( "hidden", this.mAlexaText ? "false" : "true" );
  	}
  	else
  	{
  		branch.setIntPref( "alexarankstatuspref.state", 0 );
  	  this.mAlexaState = 0;
  	  this.mAlexaRank.setAttribute( "hidden", "true" );
  	  this.mAlexaRankText.setAttribute( "hidden", "true" );
  	}
  	
  	this.initAlexaStatus( window._content.document );
  },
  
  switchAlexaTextState: function()
  {
		var preferencesService = Components.classes["@mozilla.org/preferences-service;1"].getService( Components.interfaces.nsIPrefService );
		var branch = preferencesService.getBranch( "extensions.searchstatus." );  	
  	
  	if( this.mAlexaText == 0 )
  	{
  		branch.setIntPref( "alexarankstatustextpref.state", 1 );
  	  this.mAlexaText = 1;
  	  this.mAlexaRank.setAttribute( "hidden", "true" );
  	  this.mAlexaRankText.setAttribute( "hidden", "false" );
  	}
  	else
  	{
  		branch.setIntPref( "alexarankstatustextpref.state", 0 );
  	  this.mAlexaText = 0;
  	  this.mAlexaRank.setAttribute( "hidden", "false" );
  	  this.mAlexaRankText.setAttribute( "hidden", "true" );
  	}
  	
  	this.initAlexaStatus( window._content.document );
  },

  hideAlexaTooltip: function()
  {
  	this.mAlexaRank.setAttribute( "tooltip", "" );
  },
  
  showAlexaTooltip: function()
  {
  	this.mAlexaRank.setAttribute( "tooltip", "alexarank-tooltip" );
  },

  showAlexaTrafficDetails: function( item )
  {
  	var currdomain = this.mAlexaLastURL.replace( /https?:\/\/(.+?)\/.*$/gi, "$1" );
  	var rootdomain = getRootDomain( currdomain );  	
  	var querystring = "http://www.alexa.com/siteinfo/" + ssUrlEncode( rootdomain ) + "#trafficstats";
  	
  	item.value = querystring;
  	ssOpenItemUrl( item );
  },
  
  showAlexaKeywords: function( item )
  {
    var currdomain = this.mAlexaLastURL.replace( /https?:\/\/(.+?)\/.*$/gi, "$1" );
    var rootdomain = getRootDomain( currdomain );   
    var querystring = "http://www.alexa.com/siteinfo/" + ssUrlEncode( rootdomain ) + "#keywords";
    
    item.value = querystring;
    ssOpenItemUrl( item );
  },

  showAlexaCategory: function( item )
  {
  	var cat = item.getAttribute( "tooltiptext" );
  	if( cat )
  	{
  		var link = "http://www.alexa.com/browse_redirect?catpath=" + cat;
  		ssOpenUrl( link );
  	}
  },  
  
  showDMOZCategory: function( item )
  {
  	var cat = item.getAttribute( "tooltiptext" );
  	if( cat )
  	{
  		var link = "http://dmoz.org/" + cat.substr( 4 );
  		ssOpenUrl( link );
  	}
  }, 
  
	showContactInfo: function( item )
	{
		var contactInfo = window.openDialog( "chrome://searchstatus/content/contactinfo.xul", "searchstatus-alexa-contactinfo-dialog" + this.mAlexaLastDoc.getElementsByTagName( "OWNER" ).item( 0 ).attributes.getNamedItem( "NAME" ).nodeValue, "centerscreen,chrome,modal", this.mAlexaLastDoc );
	},
  
	isPrivateSite: function( url )
	{
		var preferencesService = Components.classes["@mozilla.org/preferences-service;1"].getService( Components.interfaces.nsIPrefService );
		var branch = preferencesService.getBranch( "extensions.searchstatus." );    	
		
		if( branch.prefHasUserValue( "searchstatus.privatesiteslist" ) )
		{
			var sitestring = branch.getCharPref( "searchstatus.privatesiteslist" );
			var sites = sitestring.split( "!" );
			
			var lowerurl = url.toLowerCase();
			for( var i = 0; i < sites.length; i++ )
			{
				if( sites[i].length > 0 && lowerurl.indexOf( sites[i].toLowerCase() ) > -1 )
				{
					debugss( url + " matches private site " + sites[i] + ", ignoring" );
					return true;
				}
			}
		}
		
		return false;
	}, 
	
	isRelatedLinksOnBar: function()
	{
		var preferencesService = Components.classes["@mozilla.org/preferences-service;1"].getService( Components.interfaces.nsIPrefService );
		var branch = preferencesService.getBranch( "extensions.searchstatus." );    	
		
		if( branch.prefHasUserValue( "searchstatus.relatedlinksonbar" ) )
		{
			return branch.getBoolPref( "searchstatus.relatedlinksonbar" );
		}
		
		return false;
	}, 
  
  initCompeteStatus: function( doc, loadFresh ) 
  { 
  	var url = doc.location.toString();
  	if( url != window._content.document.location.toString() )
  	{
  		return;
  	}  	
  		
    var urlIndex = 0;
    
   	debugss( "For compete url " + url + ": " + getArrayIndex( this.mCompeteRankCache, url ) + ", " + getArrayIndex( this.mCompeteRankCacheNa, url ) );

  	if( this.mCompeteState == 0 )
    {
    	//this.mCompeteRank.setAttribute( "hidden", "true" );
    }
  	else
  	{
  		if( this.mCompeteText == 0 )
  		{ 
  			this.mCompeteRank.setAttribute( "hidden", "false" );
  		}
  		else
  		{
  			this.mCompeteRankText.setAttribute( "hidden", "false" );
  		}
  		
      var unrankable = this.getUnrankableStatus( url );
      if( unrankable )
      {
        this.mCompeteLastDoc = unrankable;
        this.initCompeteFromDoc( this.mCompeteLastDoc );
      }  		
  		else if( !loadFresh && ( urlIndex = getArrayIndex( this.mCompeteRankCache, url ) ) >= 0 )
  	  {
  	    this.mCompeteLastDoc = this.mCompeteRankCache[urlIndex][1];
  	    this.initCompeteFromDoc( this.mCompeteLastDoc );
  	  }	
  		else if( !loadFresh && ( urlIndex = getArrayIndex( this.mCompeteRankCacheNa, url ) ) >= 0 )
  	  {
  	    this.mCompeteLastDoc = this.mCompeteRankCacheNa[urlIndex][1];
  	    this.initCompeteFromDoc( this.mCompeteLastDoc );
  	  }		  
  		else
  		{
  		  this.mCompeteLastDoc = "unranked";
        this.initCompeteFromDoc( this.mCompeteLastDoc );
  			
				var strippedUrl = url.replace( /https?:\/\/(.+)$/gi, "$1" );
  			var encodedUrl = ssUrlEncode( strippedUrl );
  			var querystring = this.isAnonymize() ? "http://www.anonymization.org/-" : "http://";
				//querystring += "api.compete.com/fast-cgi/MI?d=" + encodedUrl + "&ver=3&apikey=8am9my8a549a6gm8zqkyjg42&size=small";
				querystring += "dcs.consumerinput.com/fast-cgi/MI?ver=3ss&userid=" + this.mInstallDate + "&registrar=searchstatus&d=" + encodedUrl;

  			if( querystring != this.mCompeteQuerystring || loadFresh )
  			{
					debugss( "asking compete..." );
  			
	  			this.mCompeteRequest = new XMLHttpRequest();
	  	    this.mCompeteRequest.onload = onCompeteRequestLoad;
	  	    this.mCompeteRequest.open( "GET", querystring );
	        this.mCompeteRequest.setRequestHeader( "Accept-Encoding", "none" );
	  			this.mCompeteRequest.send( null );
  				this.mCompeteQuerystring = querystring;
  			}
  		}
  	}

  	this.mCompeteLastURL = url;
  },

  setCompeteStatus: function()
  {
  	var aDoc = this.mCompeteRequest.responseXML;
  	debugss( "setCompeteStatus " + aDoc );
  	
  	this.initCompeteFromDoc( aDoc );
  	this.mCompeteLastDoc = aDoc;
  	
  	if( aDoc == -1 )
  	{
  		this.mCompeteRankCacheNa.push( new Array( this.mCompeteLastURL, aDoc ) );  		
  	}
  	else
  	{
  		this.mCompeteRankCache.push( new Array( this.mCompeteLastURL, aDoc ) );
  	}
  },

  initCompeteFromDoc: function( aDoc )
  {
    if( aDoc == null || aDoc == -1 )
    {
      aDoc = "unrankable";
    }
  
  	if( typeof aDoc == "string" )
  	{
  		this.mCompeteRank.setAttribute( "status", aDoc == "unranked" ? "-" : "" );
  		this.mCompeteRankText.setAttribute( "label", "Compete Rank: " + aDoc );
  		this.mCompeteTooltip.setAttribute( "value", "Compete Rank: " + aDoc );
			this.mCompeteVisitors.setAttribute( "label", "Show Visitors" );
			this.mCompeteVisitors.setAttribute( "disabled", "true" );
  	}
  	else
  	{
  		if( aDoc.getElementsByTagName( "ranking" ).length > 0 )
  		{
	  		var element = aDoc.getElementsByTagName( "ranking" ).item( 0 );
	  		var cr = element.firstChild.data;
	  		
	  		this.mCompeteRank.setAttribute( "status", this.getCompeteStatus( cr ) );
	  		this.mCompeteRankText.setAttribute( "label", "Compete Rank: " + ssFormatInteger( cr ) );
	  		this.mCompeteTooltip.setAttribute( "value", "Compete Rank: " + ssFormatInteger( cr ) );
	
				if( aDoc.getElementsByTagName( "count" ).length > 0 )
				{
					var countElement = aDoc.getElementsByTagName( "count" ).item( 0 );
					var cc = countElement.firstChild.data;
					this.mCompeteVisitors.setAttribute( "label", "Show Visitors (" + ssFormatInteger( cc ) + ")" );
					this.mCompeteVisitors.setAttribute( "disabled", "false" );
				}
	  	}
	  	else
	  	{
	  		this.mCompeteRank.setAttribute( "status", "" );
	  		this.mCompeteRankText.setAttribute( "label", "Compete Rank: n/a" );
  			this.mCompeteTooltip.setAttribute( "value", "Compete Rank: n/a" );
				this.mCompeteVisitors.setAttribute( "label", "Show Visitors" );
				this.mCompeteVisitors.setAttribute( "disabled", "true" );
	  	}
  	}
  },

  getCompeteStatus: function( ar )
  {
		ar = ar.replace(/,/g, "" ).replace(/^\s\s*/, '').replace(/\s\s*$/, '');
	
  	if( ar <= 0 )
  	{
  		return 0;
  	}
  	
  	var rank = Math.log( ar ) / Math.log( 5 );
  	rank = Math.floor( rank );
  	if( rank > 10 )
  	{
  		rank = 10;	
  	}

  	return ( 10 - rank );
  },

  resetCompeteStatus: function( doc )
  {
  	var showcompete = document.getElementById( "searchstatus-showcompeterank" );
  	showcompete.setAttribute( "checked", this.mCompeteState ? "true" : "false" );
  	
  	var showcompetetext = document.getElementById( "competerank-showtext" );
  	showcompetetext.setAttribute( "checked", this.mCompeteText ? "true" : "false" );	  	
  	
  	var url = doc.location.toString();
  	
  	if( this.mCompeteState == 0 )
  	{
    	this.mCompeteRank.setAttribute( "hidden", "true" );
    	this.mCompeteRankText.setAttribute( "hidden", "true" );
  	}
  	else
  	{
  		this.mCompeteRank.setAttribute( "hidden", this.mCompeteText ? "true" : "false" );
  		this.mCompeteRankText.setAttribute( "hidden", this.mCompeteText ? "false" : "true" );
  		
  		if( url == this.mCompeteLastURL )
  		{
  			this.initCompeteFromDoc( this.mCompeteLastDoc );
  		}
  		else
  		{
  		  this.initCompeteStatus( doc );	
  		}
  	}
  },

  switchCompeteState: function()
  {
		var preferencesService = Components.classes["@mozilla.org/preferences-service;1"].getService( Components.interfaces.nsIPrefService );
		var branch = preferencesService.getBranch( "extensions.searchstatus." );  	
  	
  	if( this.mCompeteState == 0 )
  	{
  		branch.setIntPref( "competerankstatuspref.state", 1 );
  	  this.mCompeteState = 1;
  	  this.mCompeteRank.setAttribute( "hidden", this.mCompeteText ? "true" : "false" );
  		this.mCompeteRankText.setAttribute( "hidden", this.mCompeteText ? "false" : "true" );
  	}
  	else
  	{
  		branch.setIntPref( "competerankstatuspref.state", 0 );
  	  this.mCompeteState = 0;
  	  this.mCompeteRank.setAttribute( "hidden", "true" );
  	  this.mCompeteRankText.setAttribute( "hidden", "true" );
  	}
  	
  	this.initCompeteStatus( window._content.document );
  },
  
  switchCompeteTextState: function()
  {
		var preferencesService = Components.classes["@mozilla.org/preferences-service;1"].getService( Components.interfaces.nsIPrefService );
		var branch = preferencesService.getBranch( "extensions.searchstatus." );  	
  	
  	if( this.mCompeteText == 0 )
  	{
  		branch.setIntPref( "competerankstatustextpref.state", 1 );
  	  this.mCompeteText = 1;
  	  this.mCompeteRank.setAttribute( "hidden", "true" );
  	  this.mCompeteRankText.setAttribute( "hidden", "false" );
  	}
  	else
  	{
  		branch.setIntPref( "competerankstatustextpref.state", 0 );
  	  this.mCompeteText = 0;
  	  this.mCompeteRank.setAttribute( "hidden", "false" );
  	  this.mCompeteRankText.setAttribute( "hidden", "true" );
  	}
  	
  	this.initCompeteStatus( window._content.document );
  },

  hideCompeteTooltip: function()
  {
  	this.mCompeteRank.setAttribute( "tooltip", "" );
  },
  
  showCompeteTooltip: function()
  {
  	this.mCompeteRank.setAttribute( "tooltip", "competerank-tooltip" );
  },

  showCompeteSnapshot: function( item )
  {
  	var currdomain = this.getDomain();
  	var querystring = "http://snapshot.compete.com/" + ssUrlEncode( currdomain ) + "?src=3ss";
  	
  	item.value = querystring;
  	ssOpenItemUrl( item );
  },

  initLinkscapeStatus: function( doc, loadFresh ) 
  { 
  	var url = doc.location.toString();
  	if( url != window._content.document.location.toString() )
  	{
  		return;
  	}  	
  		
    var urlIndex = 0;
    
   	debugss( "For linkscape url " + url + ": " + getArrayIndex( this.mLinkscapeRankCache, url ) + ", " + getArrayIndex( this.mLinkscapeRankCacheNa, url ) );

  	if( this.mLinkscapeState == 0 )
    {
    	//this.mLinkscapeRank.setAttribute( "hidden", "true" );
    }
  	else
  	{
  		if( this.mLinkscapeText == 0 )
  		{ 
  			this.mLinkscapeRank.setAttribute( "hidden", "false" );
  		}
  		else
  		{
  			this.mLinkscapeRankText.setAttribute( "hidden", "false" );
  		}
  		
  		var unrankable = this.getUnrankableStatus( url );
      if( unrankable )
      {
        this.mLinkscapeLastDoc = unrankable;
        this.initLinkscapeFromDoc( this.mLinkscapeLastDoc );
      }
  		else if( !loadFresh && ( urlIndex = getArrayIndex( this.mLinkscapeRankCache, url ) ) >= 0 )
  	  {
  	    this.mLinkscapeLastDoc = this.mLinkscapeRankCache[urlIndex][1];
  	    this.initLinkscapeFromDoc( this.mLinkscapeLastDoc );
  	  }	
  		else if( !loadFresh && ( urlIndex = getArrayIndex( this.mLinkscapeRankCacheNa, url ) ) >= 0 )
  	  {
  	    this.mLinkscapeLastDoc = this.mLinkscapeRankCacheNa[urlIndex][1];
  	    this.initLinkscapeFromDoc( this.mLinkscapeLastDoc );
  	  }		  
  		else
  		{
        this.mLinkscapeLastDoc = "unranked";
  			this.initLinkscapeFromDoc( this.mLinkscapeLastDoc );
  			
				var strippedUrl = url.replace( /https?:\/\/(.+)$/gi, "$1" );
  			var encodedUrl = ssUrlEncode( strippedUrl );
  			
  			var accessId = "quirk";
  			
  			var now = new Date;
				var unixtime_ms = now.getTime(); 
				var unixtime = parseInt( unixtime_ms / 1000 );
				var expires = unixtime + 300;
  			
  			var sigData = accessId + "\n" + expires;
  			var base64Sig = gLinkscapeSHACalc.b64_hmac_sha1( "D3m04qU1rK", sigData );
  			var encodedSig = ssUrlEncode( base64Sig );
  			
  			var querystring = this.isAnonymize() ? "http://www.anonymization.org/-" : "http://";
				querystring += "lsapi.seomoz.com/linkscape/mozrank/" + encodedUrl + "?AccessID=" + accessId + "&Expires=" + expires + "&Signature=" + encodedSig;

  			if( querystring != this.mLinkscapeQuerystring || loadFresh )
  			{
					debugss( "asking linkscape... " + querystring );
  			
	  			this.mLinkscapeRequest = new XMLHttpRequest();
	  	    this.mLinkscapeRequest.onload = onLinkscapeRequestLoad;
	  	    this.mLinkscapeRequest.open( "GET", querystring );
	        this.mLinkscapeRequest.setRequestHeader( "Accept-Encoding", "none" );
	  			this.mLinkscapeRequest.send( null );
  				this.mLinkscapeQuerystring = querystring;
  			}
  		}
  	}

  	this.mLinkscapeLastURL = url;
  },

  setLinkscapeStatus: function()
  {
  	var aDoc = this.mLinkscapeRequest.responseText;
  	debugss( "setLinkscapeStatus " + aDoc );
  	
  	this.initLinkscapeFromDoc( aDoc );
  	this.mLinkscapeLastDoc = aDoc;
  	
  	if( aDoc == -1 )
  	{
  		this.mLinkscapeRankCacheNa.push( new Array( this.mLinkscapeLastURL, aDoc ) );  		
  	}
  	else
  	{
  		this.mLinkscapeRankCache.push( new Array( this.mLinkscapeLastURL, aDoc ) );
  	}
  },

  initLinkscapeFromDoc: function( aDoc )
  {
    if( aDoc == null || aDoc == -1 || aDoc.length == 0 )
    {
      aDoc = "unrankable";
    }

  	if( aDoc.length < 15 )
  	{
  		this.mLinkscapeRank.setAttribute( "status", aDoc == "unranked" ? "-" : "" );
  		this.mLinkscapeRankText.setAttribute( "label", "mozRank: " + aDoc );
  		this.mLinkscapeTooltip.setAttribute( "value", "mozRank: " + aDoc );
  		this.mLinkscapeLinkCount.setAttribute( "label", "Show External Link Count" );
  		this.mLinkscapeDomainRank.setAttribute( "label", "Show Domain mozRank" );
  	}
  	else
  	{
  		var jsonDoc = JSON.parse( aDoc );
  	
  		if( jsonDoc['umrp'] != null )
  		{
  			var rank = jsonDoc['umrp'];
  			var intRank = Math.floor( rank ); 
  		
	  		this.mLinkscapeRank.setAttribute( "status", intRank );
	  		this.mLinkscapeRankText.setAttribute( "label", "mozRank: " + ssFormatDouble( rank ) );
	  		this.mLinkscapeTooltip.setAttribute( "value", "mozRank: " + ssFormatDouble( rank ) );
	  		
	  		var extLink = jsonDoc['ueid'];
	  		if( extLink != null )
	  		{
	  			this.mLinkscapeLinkCount.setAttribute( "label", "Show External Link Count (" + ssFormatInteger( new String( extLink ) ) + ")" );
	  		}
	  		
	  		var domainRank = jsonDoc['fmrp'];
	  		if( domainRank != null )
	  		{
	  		  this.mLinkscapeDomainRank.setAttribute( "label", "Show Domain mozRank (" + ssFormatDouble( domainRank ) + ")" );
	  		}
	  	}
	  	else
	  	{
	  		this.mLinkscapeRank.setAttribute( "status", "" );
	  		this.mLinkscapeRankText.setAttribute( "label", "mozRank: n/a" );
  			this.mLinkscapeTooltip.setAttribute( "value", "mozRank: n/a" );
  			this.mLinkscapeLinkCount.setAttribute( "label", "Show External Link Count" );
  			this.mLinkscapeDomainRank.setAttribute( "label", "Show Domain mozRank" );
	  	}
  	}
  },

  resetLinkscapeStatus: function( doc )
  {
  	var showlinkscape = document.getElementById( "searchstatus-showlinkscaperank" );
  	showlinkscape.setAttribute( "checked", this.mLinkscapeState ? "true" : "false" );
  	
  	var showlinkscapetext = document.getElementById( "linkscaperank-showtext" );
  	showlinkscapetext.setAttribute( "checked", this.mLinkscapeText ? "true" : "false" );	  	
  	
  	var url = doc.location.toString();
  	
  	if( this.mLinkscapeState == 0 )
  	{
    	this.mLinkscapeRank.setAttribute( "hidden", "true" );
    	this.mLinkscapeRankText.setAttribute( "hidden", "true" );
  	}
  	else
  	{
  		this.mLinkscapeRank.setAttribute( "hidden", this.mLinkscapeText ? "true" : "false" );
  		this.mLinkscapeRankText.setAttribute( "hidden", this.mLinkscapeText ? "false" : "true" );
  		
  		if( url == this.mLinkscapeLastURL )
  		{
  			this.initLinkscapeFromDoc( this.mLinkscapeLastDoc );
  		}
  		else
  		{
  		  this.initLinkscapeStatus( doc );	
  		}
  	}
  },

  switchLinkscapeState: function()
  {
		var preferencesService = Components.classes["@mozilla.org/preferences-service;1"].getService( Components.interfaces.nsIPrefService );
		var branch = preferencesService.getBranch( "extensions.searchstatus." );  	
  	
  	if( this.mLinkscapeState == 0 )
  	{
  		branch.setIntPref( "linkscaperankstatuspref.state", 1 );
  	  this.mLinkscapeState = 1;
  	  this.mLinkscapeRank.setAttribute( "hidden", this.mLinkscapeText ? "true" : "false" );
  		this.mLinkscapeRankText.setAttribute( "hidden", this.mLinkscapeText ? "false" : "true" );
  	}
  	else
  	{
  		branch.setIntPref( "linkscaperankstatuspref.state", 0 );
  	  this.mLinkscapeState = 0;
  	  this.mLinkscapeRank.setAttribute( "hidden", "true" );
  	  this.mLinkscapeRankText.setAttribute( "hidden", "true" );
  	}
  	
  	this.initLinkscapeStatus( window._content.document );
  },
  
  switchLinkscapeTextState: function()
  {
		var preferencesService = Components.classes["@mozilla.org/preferences-service;1"].getService( Components.interfaces.nsIPrefService );
		var branch = preferencesService.getBranch( "extensions.searchstatus." );  	
  	
  	if( this.mLinkscapeText == 0 )
  	{
  		branch.setIntPref( "linkscaperankstatustextpref.state", 1 );
  	  this.mLinkscapeText = 1;
  	  this.mLinkscapeRank.setAttribute( "hidden", "true" );
  	  this.mLinkscapeRankText.setAttribute( "hidden", "false" );
  	}
  	else
  	{
  		branch.setIntPref( "linkscaperankstatustextpref.state", 0 );
  	  this.mLinkscapeText = 0;
  	  this.mLinkscapeRank.setAttribute( "hidden", "false" );
  	  this.mLinkscapeRankText.setAttribute( "hidden", "true" );
  	}
  	
  	this.initLinkscapeStatus( window._content.document );
  },

  hideLinkscapeTooltip: function()
  {
  	this.mLinkscapeRank.setAttribute( "tooltip", "" );
  },
  
  showLinkscapeTooltip: function()
  {
  	this.mLinkscapeRank.setAttribute( "tooltip", "linkscaperank-tooltip" );
  },
  
  showLinkscapeReport: function( item )
  {
  	var url = new String( window._content.document.location );
  	var strippedUrl = url.replace( /https?:\/\/(.+)$/gi, "$1" );
  	var querystring = "http://www.seomoz.org/linkscape/intel/basic/?uri=" + ssUrlEncode( strippedUrl );
  	
  	item.value = querystring;
  	ssOpenItemUrl( item );
  },
  
  showDomainLinkscapeReport: function( item )
  {
    var url = new String( window._content.document.location );
    var strippedUrl = url.replace( /https?:\/\/(.+?)\/.*$/gi, "$1" );
    var querystring = "http://www.seomoz.org/linkscape/intel/basic/?uri=" + ssUrlEncode( strippedUrl );
    
    item.value = querystring;
    ssOpenItemUrl( item );
  },
  
  showLinkscapeTools: function( item )
  {
  	ssOpenUrl( 'http://www.seomoz.org/tools' );
  },
  
	isAnonymize: function()
	{
		return false;
		
//		var preferencesService = Components.classes["@mozilla.org/preferences-service;1"].getService( Components.interfaces.nsIPrefService );
//		var branch = preferencesService.getBranch( "extensions.searchstatus." );    	
//		
//		if( branch.prefHasUserValue( "searchstatus.anonymize" ) )
//		{
//			return branch.getBoolPref( "searchstatus.anonymize" );
//		}
//		
//		return false;
	},
	
  switchHighlightNofollowState: function()
  {
		var preferencesService = Components.classes["@mozilla.org/preferences-service;1"].getService( Components.interfaces.nsIPrefService );
		var branch = preferencesService.getBranch( "extensions.searchstatus." );  	
  	
  	if( this.mHighlightNofollow == 0 )
  	{
  		branch.setIntPref( "highlightnofollowpref.state", 1 );
  	  this.mHighlightNofollow = 1;
  	  this.highlightNofollow( null, true );
  	}
  	else
  	{
  		branch.setIntPref( "highlightnofollowpref.state", 0 );
  	  this.mHighlightNofollow = 0;
  	  this.highlightNofollow( null, false );
  	}
  	
  	this.initGoogleStatus( window._content.document );
  },  	
  
  highlightNofollow: function( doc, highlight )
  {
    const mainTabBox   = getBrowser().mTabBox;
    const documentList = ( doc == null ? this.getDocuments( getBrowser().browsers[mainTabBox.selectedIndex].contentWindow, new Array() ) : new Array( doc ) );

		var id = "searchstatus-nofollow";
    var element      = null;
    var pageDocument = null;

    // Loop through the documents
    for(var i = 0; i < documentList.length; i++)
    {
      pageDocument = documentList[i];

      // Remove all elements with that id
      while( ( element = pageDocument.getElementById( id ) ) != null )
      {
        element.parentNode.removeChild( element );
      }
    }

		if( highlight ) 
		{
	    var headElementList = null;
	    var linkElement     = null;
	
	    // Loop through the documents
	    for( var i = 0; i < documentList.length; i++ )
	    {
	      pageDocument    = documentList[i];
	      
	      var nofollowall = false;
	      var tags = pageDocument.getElementsByTagName( "meta" );
	      for( var j = 0; j < tags.length; j++ )
				{
					var tag = tags.item( j );
					
	      	if( tag.hasAttribute( "name") && tag.getAttribute( "name" ).toLowerCase() == "robots"  && tag.hasAttribute( "content" ) && ( tag.getAttribute( "content" ).toLowerCase().indexOf( "nofollow" ) > -1 || tag.getAttribute( "content" ).toLowerCase().indexOf( "none" ) > -1 ) )
	      	{
	      		 nofollowall = true;
	      	}
	     	}
	      
	      headElementList = pageDocument.getElementsByTagName( "head" );
	      styleElement    = pageDocument.createElement( "style" );
	      styleElement.setAttribute( "id", id );
	      styleText       = pageDocument.createTextNode( "a" + ( nofollowall ? "" : "[rel~=\"nofollow\"]" ) + " {  outline: thin dashed firebrick ! important;  background-color: rgb(255, 200, 200) ! important; }" );
				styleElement.appendChild( styleText );
	
	      // If there is a head element
	      if( headElementList.length > 0 )
	      {
	        headElementList[0].appendChild( styleElement );
	      }
	      else if( pageDocument.documentElement.tagName == "HTML" )
	      {
	        pageDocument.documentElement.appendChild( styleElement );
	      }
	    }
	  }
  },

	getDocuments: function( frame, documentList )
	{
    const framesList = frame.frames;
    documentList.push( frame.document );
    
    // Loop through the frames
    for( var i = 0; i < framesList.length; i++ )
    {
      this.getDocuments( framesList[i], documentList );
    }

    return documentList;
	},
	
	highlightSearchTerms: function( doc, searchText )
	{
	  var searchArray = [searchText,searchText.replace(/-/g, " "),searchText.replace(/ /g, "-")];
	  
	  if( !doc.body || typeof( doc.body.innerHTML ) == "undefined") 
	  {
	    return false;
	  }
	  
	  var bodyText = doc.body.innerHTML;
	  for( var i = 0; i < searchArray.length; i++ ) 
	  {
	    bodyText = this.doHighlight( bodyText, searchArray[i], this.mHighlightColours[this.mHighlightColourIndex] );
	  }
	  
	  this.mHighlightColourIndex++;
	  if( this.mHighlightColourIndex >= this.mHighlightColours.length )
	  {
	  	this.mHighlightColourIndex = 0;
	  }
	  
	  doc.body.innerHTML = bodyText;
	  
	  return true;
	},  
  
	doHighlight: function( bodyText, searchTerm, colour ) 
	{
    var highlightStartTag = "<font style='background-color: rgb(" + colour + ") ! important;'>";
	  var highlightEndTag = "</font>";
	  
	  // find all occurences of the search term in the given text,
	  // and add some "highlight" tags to them (we're not using a
	  // regular expression search, because we want to filter out
	  // matches that occur within HTML tags and script blocks, so
	  // we have to do a little extra validation)
	  var newText = "";
	  var i = -1;
	  var l = searchTerm.length;
	  var lcSearchTerm = searchTerm.toLowerCase();
	  var lcBodyText = bodyText.toLowerCase();
	  
		var spaceTerm = lcSearchTerm.replace( /-/g, " " );
	  var dashTerm = lcSearchTerm.replace( / /g, "-" );  
	    
	  var re = new RegExp( /\W/ );
	    
	  while( bodyText.length > 0 ) 
	  {
	    i = lcBodyText.indexOf( lcSearchTerm, i + 1 );
	    
	    if( i < 0 ) 
	    {
	      newText += bodyText;
	      bodyText = "";
	    } 
	    else 
	  	{
	      // skip anything inside an HTML tag
	      if( bodyText.lastIndexOf( ">", i ) >= bodyText.lastIndexOf( "<", i ) ) 
	      {
	        // skip anything inside a <script> block
	        if( lcBodyText.lastIndexOf( "/script>", i ) >= lcBodyText.lastIndexOf( "<script", i ) ) 
	        {
	        	// skip if no word boundary
	        	if( i == 0 || i+l == lcBodyText.length || ( re.test( lcBodyText.substring( i-1, i ) ) && re.test( lcBodyText.substring( i+l, i+l+1 ) ) ) )
	        	{	        	
		          newText += bodyText.substring( 0, i ) + highlightStartTag + bodyText.substr( i, searchTerm.length ) + highlightEndTag;
		          bodyText = bodyText.substr( i + searchTerm.length );
		          lcBodyText = bodyText.toLowerCase();
		          i = -1;
		        }
	        }
	      }
	    }
	  }
	  
	  return newText;
	},
	
	getCanonicalLink: function( doc )
	{
		var linkElements = doc.getElementsByTagName( "link" );
		for( var i = 0; i < linkElements.length; i++ )
		{
			var relAttr = linkElements[i].getAttribute( "rel" );
		
			if( relAttr && relAttr.toLowerCase() == "canonical" )
			{
				var href = linkElements[i].getAttribute( "href" );
				if( href.indexOf( '/' ) == 0 )
				{
				  var domain = doc.location.toString().replace( /(https?:\/\/.+?)\/.*$/gi, "$1" );
				  href = domain + href;
				}
				
				return href;
			}
		}
		
		return null;
	},
	
	showCanonical: function( item )
  {
  	if( this.mCanonicalButton.getAttribute( "status" ) == "disabled" )
  	{
  		return;
  	}
  
  	document.getElementById( 'content' ).loadURI( this.mCanonicalButton.getAttribute( "link" ) );
  }
};

function googlechcalc()
{
  return this; 
}

googlechcalc.prototype =
{
  googleNewCh: function( ch )
  {
  	ch = ( ( ( ch / 7 ) << 2 ) | ( ( this.myfmod( ch,13 ) ) & 7 ) );
  
  	prbuf = new Array();
  	prbuf[0] = ch;
  	for( i = 1; i < 20; i++ ) 
  	{
      prbuf[i] = prbuf[i-1] - 9;
  	}
  	ch = this.googleCH( this.c32to8bit( prbuf ), 80 );
  	
  	return ch;		
  },

  googleCH: function( url ) 
  {
		var init = 0xE6359A60;
		
		var length = url.length;
		
		var a = 0x9E3779B9;
		var b = 0x9E3779B9;
		var c = 0xE6359A60;
		var k = 0;
		var len = length;
		var mixo = new Array(); 
				
		while( len >= 12 ) 
		{
			a += (url[k+0] +(url[k+1]<<8) +(url[k+2]<<16) +(url[k+3]<<24));
			b += (url[k+4] +(url[k+5]<<8) +(url[k+6]<<16) +(url[k+7]<<24));
			c += (url[k+8] +(url[k+9]<<8) +(url[k+10]<<16)+(url[k+11]<<24));
			mixo = this.mix(a,b,c);
			a = mixo[0]; b = mixo[1]; c = mixo[2];
			k += 12;
			len -= 12;
		}
		
		c += length;
		
		switch( len ) 
		{
			case 11:
			c += url[k+10]<<24;
			
			case 10: 
			c+=url[k+9]<<16;
			
			case 9 : 
			c+=url[k+8]<<8;
			
			case 8 : 
			b+=(url[k+7]<<24);
			
			case 7 : 
			b+=(url[k+6]<<16);
			
			case 6 : 
			b+=(url[k+5]<<8);
			
			case 5 : 
			b+=(url[k+4]);
			
			case 4 : 
			a+=(url[k+3]<<24);
			
			case 3 : 
			a+=(url[k+2]<<16);
			
			case 2 : 
			a+=(url[k+1]<<8);
			
			case 1 : 
			a+=(url[k+0]);
		}
		
		mixo = this.mix( a, b, c );
		
		if( mixo[2] < 0 )
		{
			return ( 0x100000000 + mixo[2] );
		}
	  else
	  {
			return mixo[2];
		}
  },

  hexdec: function( str )
  {
  	return parseInt( str, 16 );
  },
  
  zeroFill: function( a, b )
  {
  	var z = this.hexdec( 80000000 );
  	
  	if( z & a )
  	{
  		a = a >> 1;
  		a &= ~z;
  		a |= 0x40000000;
  		a = a >> ( b - 1 );
  	} 
  	else
  	{
  		a = a >> b;
  	}
  	
  	return (a);
  },
  
  mix: function( a, b, c ) 
  {
  	a -= b; a -= c; a ^= ( this.zeroFill( c, 13 ) );
  	b -= c; b -= a; b ^= ( a << 8 );
  	c -= a; c -= b; c ^= ( this.zeroFill( b, 13 ) );
  	a -= b; a -= c; a ^= ( this.zeroFill( c, 12 ) );
  	b -= c; b -= a; b ^= ( a << 16);
  	c -= a; c -= b; c ^= ( this.zeroFill( b, 5 ) );
  	a -= b; a -= c; a ^= ( this.zeroFill( c, 3 ) ); 
  	b -= c; b -= a; b ^= ( a << 10);
  	c -= a; c -= b; c ^= ( this.zeroFill( b, 15 ) );
  	
  	var ret = new Array( (a), (b), (c) );
  	
  	return ret;
  },

  strord: function( string ) 
  {
  	var result = new Array();
  	for( i = 0; i < string.length; i++ ) 
  	{
  		result[i] = string[i].charCodeAt( 0 );
  	}
  	
  	return result;
  },
  
  c32to8bit: function( arr32 ) 
  {
    var arr8 = new Array();	
    
    for( i = 0; i < arr32.length; i++ ) 
    {
    	for( bitOrder = i * 4; bitOrder <= i * 4 + 3; bitOrder++ ) 
    	{
        arr8[bitOrder] = arr32[i] & 255;
        arr32[i] = this.zeroFill( arr32[i], 8 );
      }
    }
    
    return arr8;
  },
  
  myfmod: function( x, y )
  {
  	var i = Math.floor( x / y );
    return ( x - i * y );
  }
};

function linkscapeshacalc()
{
  return this; 
}

linkscapeshacalc.prototype =
{
	b64pad: "=", /* base-64 pad character. "=" for strict RFC compliance   */
	chrsz: 8,  /* bits per input character. 8 - ASCII; 16 - Unicode      */

	/*
	 * These are the functions you'll usually want to call
	 * They take string arguments and return either hex or base-64 encoded strings
	 */
	b64_hmac_sha1: function(key, data)
	{ 
		return this.binb2b64(this.core_hmac_sha1(key, data));
	},
	
	/*
	 * Calculate the SHA-1 of an array of big-endian words, and a bit length
	 */
	core_sha1: function(x, len)
	{
	  /* append padding */
	  x[len >> 5] |= 0x80 << (24 - len % 32);
	  x[((len + 64 >> 9) << 4) + 15] = len;
	
	  var w = Array(80);
	  var a =  1732584193;
	  var b = -271733879;
	  var c = -1732584194;
	  var d =  271733878;
	  var e = -1009589776;
	
	  for(var i = 0; i < x.length; i += 16)
	  {
	    var olda = a;
	    var oldb = b;
	    var oldc = c;
	    var oldd = d;
	    var olde = e;
	
	    for(var j = 0; j < 80; j++)
	    {
	      if(j < 16) w[j] = x[i + j];
	      else w[j] = this.rol(w[j-3] ^ w[j-8] ^ w[j-14] ^ w[j-16], 1);
	      var t = this.safe_add(this.safe_add(this.rol(a, 5), this.sha1_ft(j, b, c, d)), this.safe_add(this.safe_add(e, w[j]), this.sha1_kt(j)));
	      e = d;
	      d = c;
	      c = this.rol(b, 30);
	      b = a;
	      a = t;
	    }
	
	    a = this.safe_add( a, olda );
	    b = this.safe_add( b, oldb );
	    c = this.safe_add( c, oldc );
	    d = this.safe_add( d, oldd );
	    e = this.safe_add( e, olde );
	  }
	  
	  return Array(a, b, c, d, e);
	},
	
	/*
	 * Perform the appropriate triplet combination function for the current
	 * iteration
	 */
	sha1_ft: function(t, b, c, d)
	{
	  if(t < 20) return (b & c) | ((~b) & d);
	  if(t < 40) return b ^ c ^ d;
	  if(t < 60) return (b & c) | (b & d) | (c & d);
	  return b ^ c ^ d;
	},
	
	/*
	 * Determine the appropriate additive constant for the current iteration
	 */
	sha1_kt: function(t)
	{
	  return (t < 20) ?  1518500249 : (t < 40) ?  1859775393 :
	         (t < 60) ? -1894007588 : -899497514;
	},
	
	/*
	 * Calculate the HMAC-SHA1 of a key and some data
	 */
	core_hmac_sha1: function(key, data)
	{
	  var bkey = this.str2binb(key);
	  if(bkey.length > 16) bkey = this.core_sha1(bkey, key.length * this.chrsz);
	
	  var ipad = Array(16), opad = Array(16);
	  for(var i = 0; i < 16; i++)
	  {
	    ipad[i] = bkey[i] ^ 0x36363636;
	    opad[i] = bkey[i] ^ 0x5C5C5C5C;
	  }
	
	  var hash = this.core_sha1(ipad.concat(this.str2binb(data)), 512 + data.length * this.chrsz);
	  return this.core_sha1(opad.concat(hash), 512 + 160);
	},
	
	/*
	 * Add integers, wrapping at 2^32. This uses 16-bit operations internally
	 * to work around bugs in some JS interpreters.
	 */
	safe_add: function(x, y)
	{
	  var lsw = (x & 0xFFFF) + (y & 0xFFFF);
	  var msw = (x >> 16) + (y >> 16) + (lsw >> 16);
	  return (msw << 16) | (lsw & 0xFFFF);
	},
	
	/*
	 * Bitwise rotate a 32-bit number to the left.
	 */
	rol: function(num, cnt)
	{
	  return (num << cnt) | (num >>> (32 - cnt));
	},
	
	/*
	 * Convert an 8-bit or 16-bit string to an array of big-endian words
	 * In 8-bit function, characters >255 have their hi-byte silently ignored.
	 */
	str2binb: function(str)
	{
	  var bin = Array();
	  var mask = (1 << this.chrsz) - 1;
	  for(var i = 0; i < str.length * this.chrsz; i += this.chrsz)
	    bin[i>>5] |= (str.charCodeAt(i / this.chrsz) & mask) << (32 - this.chrsz - i%32);
	  return bin;
	},
	
	/*
	 * Convert an array of big-endian words to a base-64 string
	 */
	binb2b64: function(binarray)
	{
	  var tab = "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/";
	  var str = "";
	  for(var i = 0; i < binarray.length * 4; i += 3)
	  {
	    var triplet = (((binarray[i   >> 2] >> 8 * (3 -  i   %4)) & 0xFF) << 16)
	                | (((binarray[i+1 >> 2] >> 8 * (3 - (i+1)%4)) & 0xFF) << 8 )
	                |  ((binarray[i+2 >> 2] >> 8 * (3 - (i+2)%4)) & 0xFF);
	    for(var j = 0; j < 4; j++)
	    {
	      if(i * 8 + j * 6 > binarray.length * 32) str += this.b64pad;
	      else str += tab.charAt((triplet >> 6*(3-j)) & 0x3F);
	    }
	  }
	  return str;
	}
};


// Private browsing listener

function PrivateBrowsingListener() {
  this.init();
}

PrivateBrowsingListener.prototype = {
  _os: null,
  _inPrivateBrowsing: false, // whether we are in private browsing mode
  _watcher: null, // the watcher object
 
  init : function () {
    this._inited = true;
    this._os = Components.classes["@mozilla.org/observer-service;1"]
                         .getService(Components.interfaces.nsIObserverService);
    this._os.addObserver(this, "private-browsing", false);
    this._os.addObserver(this, "quit-application", false);
    try {
      var pbs = Components.classes["@mozilla.org/privatebrowsing;1"]
                          .getService(Components.interfaces.nsIPrivateBrowsingService);
      this._inPrivateBrowsing = pbs.privateBrowsingEnabled;
    } catch(ex) {
      // ignore exceptions in older versions of Firefox
    }
  },
 
  observe : function (aSubject, aTopic, aData) {
    if (aTopic == "private-browsing") {
      if (aData == "enter") {
        this._inPrivateBrowsing = true;
        if (this.watcher &&
            "onEnterPrivateBrowsing" in this._watcher) {
          this.watcher.onEnterPrivateBrowsing();
        }
      } else if (aData == "exit") {
        this._inPrivateBrowsing = false;
        if (this.watcher &&
            "onExitPrivateBrowsing" in this._watcher) {
          this.watcher.onExitPrivateBrowsing();
        }
      }
    } else if (aTopic == "quit-application") {
      this._os.removeObserver(this, "quit-application");
      this._os.removeObserver(this, "private-browsing");
    }
  },
 
  get inPrivateBrowsing() {
    return this._inPrivateBrowsing;
  },
 
  get watcher() {
    return this._watcher;
  },
 
  set watcher(val) {
    this._watcher = val;
  }
};

// Searchstatus globals

var gSearchstatus = new searchstatus();
var gSearchStatusInitialised = false;

var gGoogleCHCalc = new googlechcalc();
var gLinkscapeSHACalc = new linkscapeshacalc();
var gPrivateBrowsingListener = new PrivateBrowsingListener();

gPrivateBrowsingListener.watcher = {
  onEnterPrivateBrowsing: function() 
  {
		debugss( "entering private browsing" ); 
    gSearchstatus.setPrivateMode( true );
  },
 
  onExitPrivateBrowsing: function() 
  {
  	debugss( "leaving private browsing" );
    gSearchstatus.setPrivateMode( false );
  }
};

function searchstatusPageShow( event )
{
	if( !gSearchStatusInitialised )
  {
  	gSearchstatus.init();
  	gSearchStatusInitialised = true;
  }

  gSearchstatus.initStatus( event.target );
}

function searchstatusFocus( event )
{
	if( event.target.contentDocument )
	{
		gSearchstatus.resetStatus( event.target.contentDocument );
	}

  gSearchstatus.resetStatus( event.target );
}

// Events

window.addEventListener( "pageshow", function( event ) { searchstatusPageShow( event ); }, false );
window.addEventListener( "focus", function( event ) { searchstatusFocus( event ); }, true );

function onGoogleRequestLoad()
{
	gSearchstatus.setGoogleStatus();
}

function onAlexaRequestLoad()
{
	gSearchstatus.setAlexaStatus();
}

function onCompeteRequestLoad()
{
	gSearchstatus.setCompeteStatus();
}

function onLinkscapeRequestLoad()
{
	gSearchstatus.setLinkscapeStatus();
}

function onLocalRequestLoad()
{
	gSearchstatus.setLocalIP();
}

// General

function getRootDomain( url )
{
  var lastDot = url.lastIndexOf( '.' );
  var secondLastDot = url.lastIndexOf( '.', lastDot - 1 );
  
  if( url.substring( lastDot + 1 ).length > 2 )
  {
    if( secondLastDot > -1 && ( lastDot - secondLastDot ) > 3 )
    {
      return url.substring( secondLastDot + 1 );
    }
  }

  var thirdLastDot = url.lastIndexOf( '.', secondLastDot - 1 );
  
  if( thirdLastDot > -1 )
  {
    return url.substring( thirdLastDot + 1 );
  }
  
  return url;
}

function hideSearchStatusTooltip()
{
	document.getElementById( "searchstatus-status" ).setAttribute( "tooltip", "" );
}

function showSearchStatusTooltip()
{
	document.getElementById( "searchstatus-status" ).setAttribute( "tooltip", "searchstatus-tooltip" );
}

function showSearchStatusAbout()
{
	window.openDialog( "chrome://searchstatus/content/about.xul", "searchstatus-about-dialog", "centerscreen,chrome,modal" );
}

function showSearchStatusOptions()
{
	gSearchstatus.clearOptionsCache();
	window.openDialog( "chrome://searchstatus/content/options.xul", "searchstatus-options-dialog", "centerscreen,chrome,modal" );
}

function ssOpenItemUrl( item )
{
	ssOpenUrl( item.value );
}

function ssOpenUrl( url )
{
  var browser = document.getElementById( "content" );
  var tab = browser.addTab( url );
  
	var preferencesService = Components.classes["@mozilla.org/preferences-service;1"].getService( Components.interfaces.nsIPrefService );
	var branch = preferencesService.getBranch( "extensions.searchstatus." );  
	if( branch.prefHasUserValue( "searchstatus.backgroundopen" ) && branch.getBoolPref( "searchstatus.backgroundopen" ) )
	{
		return;
	}
	
	browser.selectedTab = tab;
}

function ssUrlEncode( url ) 
{
  return escape(url).replace(/\+/g, '%2B').replace(/\"/g, '%22').replace(/\'/g, '%27');
}

function getArrayIndex( arr, hash )
{
  var i = 0;
  var found = -1;
  
  while( found == -1 && ( i < arr.length ) )
  {
    if( arr[i][0] == hash )
    {
      found = i;
      break;
    }
    
    i++;
  }
  
  return found;
}

function ssFormatInteger( integer )
{
	var pattern = "###,###,###,###";
	var result = '';

	integerIndex = integer.length - 1;
	patternIndex = pattern.length - 1;

	while( ( integerIndex >= 0 ) && ( patternIndex >= 0 ) )
	{
		var digit = integer.charAt( integerIndex );
		integerIndex--;
		
		// Skip non-digits from the source integer (eradicate current formatting).
		if( ( digit < '0' ) || ( digit > '9') )  continue;
	
		// Got a digit from the integer, now plug it into the pattern.
		while( patternIndex >= 0 )
		{
			var patternChar = pattern.charAt( patternIndex );
			patternIndex--;
			
			// Substitute digits for '#' chars, treat other chars literally.
			if( patternChar == '#' )
			{
				result = digit + result;
				break;
			}
			else
			{
				result = patternChar + result;
			}
		}
	}
	
	return result;
}

function ssFormatDouble( double )
{
	return double.toFixed( 2 );
}

function debugss( message ) 
{
  //var time = new Date();
  //var time_string = time.getHours() + ":" + time.getMinutes() + ":" + time.getSeconds();
  //dump( "[SearchStatus " + time_string + "]: " + message + "\n" );
  
  //var aConsoleService = Components.classes["@mozilla.org/consoleservice;1"].getService(Components.interfaces.nsIConsoleService);
  //aConsoleService.logStringMessage( "SearchStatus: " + message );
}
